#include <algorithm>
#include <unordered_map>
#include <unordered_set>
//#include <unordered_multiset>
#include <vector>
#include <set>

#ifndef GRAPH_H_
#define GRAPH_H_


namespace rimlib{

struct ushash {
   size_t operator() (const std::unordered_set<int> &obj) const {
	   size_t h = 0;  for(auto &k : obj) h += k;
	 return (h);
   }
};
//typedef std::unordered_set< std::unordered_set<int>, ushash> powerset_t;
//typedef std::unordered_multiset< std::unordered_set<int>, ushash > powerset_t;





class Graph{
public:



	bool directed;
	int numNodes;
	std::unordered_set<int> * nodeLabels;

	std::unordered_map<int, std::unordered_set<int> > * outAdjList;
	std::unordered_map<int, std::unordered_set<int> > * inAdjList;


	//TODO
	//std::vector< std::unordered_set<int> > * outgoingEdges;
	//powerset_t * outgoingEdges;

	//std::unordered_multiset< int > * outgoingEdges;
	//TIntObjectHashMap<TIntHashSet>[] outAdjList;
	//TIntObjectHashMap<TIntHashSet>[] inAdjList;
	//HashMultiSet<TIntHashSet>[] outgoingEdges;
	int multiplicity;

	Graph(bool directed, int numNodes)
	{
		this->directed = directed;
		this->numNodes = numNodes;
		this->nodeLabels = new std::unordered_set<int>[numNodes];

		this->outAdjList= new std::unordered_map<int, std::unordered_set<int> >[numNodes];
		this->inAdjList = new std::unordered_map<int, std::unordered_set<int> >[numNodes];
		//this->outgoingEdges = new std::unordered_multiset< int >[numNodes];

		//TODO
		//this->outgoingEdges = new std::vector< std::unordered_set< int > >[numNodes];
		//outgoingEdges = new powerset_t[numNodes];

//		for(int i=0;i<numNodes;i++)
//		{
//			outAdjList[i] = new TIntObjectHashMap<>();
//			outAdjList[i] = new TIntObjectHashMap<>();
//			inAdjList[i] = new TIntObjectHashMap<>();
//			outgoingEdges[i]=new HashMultiSet<>();
//		}

		this->multiplicity = 0;
	}




	void addNode(int id, std::unordered_set<int> label)
	{
		nodeLabels[id] = label;
	}


	void addEdge(int source, int dest, std::unordered_set< int > edgeLabels)
	{

		//std::cout<<"addedge("<<source<<","<<dest<<")"; print_unordered_set(edgeLabels);std::cout<<std::endl;
//		outAdjList[source].put(dest,edgeLabels);
//		inAdjList[dest].put(source,edgeLabels);
		outAdjList[source][dest] = edgeLabels;
		inAdjList[dest][source] = edgeLabels;
//		Vector<TIntHashSet> powerSet=getPowerSet(edgeLabels);

		/*std::vector< std::unordered_set<int> > powerSetNodeLabs = getPowerSet(nodeLabels[dest]);
		std::vector< std::unordered_set<int> > powerSetEdgeLabs = getPowerSet(edgeLabels);
		for(auto &sNode : powerSetNodeLabs)
		{
			for(auto &sEdge : powerSetEdgeLabs)
			{
				std::unordered_set<int> setCols(sEdge);
				for(int i : sNode)
					setCols.insert(i);
				//std::cout<<"-->"; print_unordered_set(setCols);std::cout<<std::endl;
				outgoingEdges[source].insert(setCols);
			}
		}*/

		//TODO
//		int i=0;
//		for(i=0;i<powerSet.size();i++)
//		{
//			TIntHashSet setCols=new TIntHashSet(powerSet.get(i));
//			setCols.add(nodeLabels[dest]);
//			outgoingEdges[source].add(setCols);
//		}
		/*for(std::vector< std::unordered_set<int> >::iterator it = powerSet.begin(); it!=powerSet.end(); it++){
			std::unordered_set<int> setCols( *it );
			setCols.insert(nodeLabels[dest]);
			outgoingEdges[source].push_back(setCols);
		}*/



//		//System.out.println(source+"-"+dest+" --> "+setCols);
//		if(!directed)
//		{
//			outAdjList[dest].put(source,edgeLabels);
//			inAdjList[source].put(dest,edgeLabels);
//			for(i=0;i<powerSet.size();i++)
//			{
//				TIntHashSet setCols2=new TIntHashSet(powerSet.get(i));
//				setCols2.add(nodeLabels[source]);
//				outgoingEdges[dest].add(setCols2);
//			}
//		}
		if(!directed)
		{
			outAdjList[dest][source] = edgeLabels;
			inAdjList[source][dest] = edgeLabels ;

			//TODO
			/*for(std::vector< std::unordered_set<int> >::iterator it = powerSet.begin(); it!=powerSet.end(); it++){
				std::unordered_set<int> setCols( *it );
				setCols.insert(nodeLabels[source]);
				outgoingEdges[dest].push_back(setCols);
			}*/
			/*powerSetNodeLabs = getPowerSet(nodeLabels[source]);
			powerSetEdgeLabs = getPowerSet(edgeLabels);
			for(auto &sNode : powerSetNodeLabs)
			{
				for(auto &sEdge : powerSetEdgeLabs)
				{
					std::unordered_set<int> setCols(sEdge);
					for(int i : sNode)
						setCols.insert(i);
					//std::cout<<"-->"; print_unordered_set(setCols);std::cout<<std::endl;
					outgoingEdges[dest].insert(setCols);
				}
			}*/
		}
//		if(edgeLabels.size()>multiplicity)
//			multiplicity=edgeLabels.size();
		if(edgeLabels.size() > multiplicity)
			multiplicity = edgeLabels.size();
	}



	void print_unordered_set(std::unordered_set<int> &s){
		std::cout<<"{";
		for(int i : s) std::cout<<std::to_string(i)<<",";
		std::cout<<"}";
	}

	//Vector<TIntHashSet> getPowerSet(TIntHashSet setColors)
	/*std::vector< std::unordered_set<int> > getPowerSet(std::unordered_set<int> &setColors)
	{

//		std::cout<<"powerset(";
//		print_unordered_set(setColors);
//		std::cout<<")"<<std::endl;

		std::vector< std::unordered_set<int> > powerSet;
		int n = setColors.size();
		for (int i = 0; i < (1<<n); i++)
		{
			std::unordered_set<int> set;
			std::unordered_set<int>::iterator it = setColors.begin();
			for (int j = 0; j < n; j++)
			{
				int col = *it; it++;
				if ((i & (1 << j)) > 0)
					set.insert(col);
			}
			if(set.size()>0){
//				std::cout<<" ->";print_unordered_set(set);std::cout<<std::endl;
				powerSet.push_back(set);
			}
		}
		return powerSet;
	}*/


//	public int[] getNodeLabels()
//	{
//		return nodeLabels;
//	}
//
//	public TIntObjectHashMap<TIntHashSet>[] getOutAdjList()
//	{
//		return outAdjList;
//	}
//
//	public TIntObjectHashMap<TIntHashSet>[] getInAdjList()
//	{
//		return inAdjList;
//	}
//
//	public HashMultiSet<TIntHashSet>[] getOutgoingEdges()
//	{
//		return outgoingEdges;
//	}
//
//	public int getNumNodes()
//	{
//		return outAdjList.length;
//	}
//
//	public boolean isDirected()
//	{
//		return directed;
//	}

	std::vector<int> * getSymmetryConditions()
	{
		int i, j, k;
        std::vector<int *> vv=findAutomorphisms();
        std::vector<int> * listCond=new std::vector<int>[numNodes];
        //for(i=0;i<listCond.length;i++)
            //listCond[i]=new Vector<>();
        int vvsize=vv.size();
		//std::cout<<vvsize<<"\n";
		/*for (std::vector<int *>::const_iterator arr = vv.begin(); arr != vv.end(); ++arr)
		{
			int * array=*arr;
			for(i=0;i<numNodes;i++)
				std::cout << array[i] <<"\n";
		}*/
        bool broken[vvsize];
		for(i=0;i<vvsize;i++)
			broken[i]=false;
        for(i=0;i<numNodes;i++)
        {
            //std::cout<<i<<"\n";
			for(j=0;j<vvsize;j++)
            {
                if(!broken[j] && vv.at(j)[i]!=i)
                    break;
            }
            if(j<vvsize)
            {
                //std::cout<<"prova\n";
				for(k=i+1;k<numNodes;k++)
                {
                    for (j=0;j<vvsize;j++)
                    {
                        if(!broken[j] && vv.at(j)[i]==k)
                        {
							listCond[k].push_back(i);
                            break;
                        }
                    }
                }
            }
            for(j=0;j<vvsize;j++)
            {
                if(vv.at(j)[i]!=i)
                    broken[j]=true;
            }
        }
        return listCond;
	}

	std::vector<int *> findAutomorphisms()
    {
        int i, j, k;
        int g;
        int fDir[numNodes];
        int fRev[numNodes];
        for (i = 0; i < numNodes; i++) {
            fDir[i] = -1;
            fRev[i] = -1;
        }
        int sequence[numNodes][numNodes];
        for (i = 0; i < numNodes; i++)
        {
            for (j = 0; j < numNodes; j++)
            {
				if ((outAdjList[i].find(j) != outAdjList[i].end()) || (outAdjList[j].find(i) != outAdjList[j].end()))
				//if (outAdjList[i].containsKey(j) || outAdjList[j].containsKey(i))
                {
                    int numNeighs = 0;
                    for (k = 0; k < numNodes; k++)
                    {
                        if (outAdjList[j].find(k) != outAdjList[j].end())
						//if (outAdjList[j].containsKey(k))
                            numNeighs++;
						if ((outAdjList[k].find(j) != outAdjList[k].end()) && (outAdjList[j].find(k) == outAdjList[j].end()))
                        //if (outAdjList[k].containsKey(j) && !outAdjList[j].containsKey(k))
                            numNeighs++;
                    }
                    sequence[i][j] = numNeighs;
                } 
				else {
                    sequence[i][j] = 0;
                }
            }
        }
        for (i = 0; i < numNodes; i++)
            std::sort(sequence[i],sequence[i]+numNodes);
		
		/*for(i=0;i<numNodes;i++)
		{
			for(j=0;j<numNodes;j++)
				std::cout<<sequence[i][j]<<"\n";
		}*/

        bool support[numNodes*numNodes];
        for (i = 0; i < numNodes*numNodes; i++)
            support[i] = false;
        for (i = 0; i < numNodes; i++)
        {
            for (j = 0; j < numNodes; j++)
            {
                for (k = 0; k < numNodes; k++)
                {
                    if (sequence[i][k] != sequence[j][k])
                        break;
                }
                if (k >= numNodes)
                    support[i*numNodes+j] = true;
            }
        }
		
		/*for(i=0;i<numNodes*numNodes;i++)
			std::cout<<support[i]<<"\n";*/
		
        std::vector<int *> vv;
        for (g = 0; g < numNodes; g++)
        {
            if (support[g * numNodes])
            {
                fDir[0] = g;
                fRev[g] = 0;
                int pos = 1;
                isomorphicExtensions(fDir, fRev, &vv, support, pos);
                fRev[fDir[0]] = -1;
                fDir[0] = -1;
            }
        }
        return vv;
    }
	
	void isomorphicExtensions(int * fDir, int * fRev, std::vector<int *> *vv, bool * support, int pos)
    {
        int i, j;
        int cand[numNodes];
        int ncand;
        int num;
        for (i = 0; i < numNodes; i++)
            cand[i] = -1;
        if (pos == numNodes)
        {
            int * vTemp=new int[numNodes];
            for(i=0;i<numNodes;i++)
                vTemp[i]=fDir[i];
            vv->push_back(vTemp);
        }
        else
        {
            int n, m;
            bool flag;
            int count[numNodes];
            ncand = 0;
            for (i = 0; i < numNodes; i++)
                count[i] = 0;
            for (i = 0; i < numNodes; i++)
            {
                if (fDir[i] != -1)
                {
                    std::vector<int> vNei;
                    for (j = 0; j < numNodes; j++)
                    {
                        if(outAdjList[i].find(j) != outAdjList[i].end())
						//if (outAdjList[i].containsKey(j))
                            vNei.push_back(j);
						else if(outAdjList[j].find(i) != outAdjList[j].end())
                        //else if (outAdjList[j].containsKey(i))
                            vNei.push_back(j);
                    }
                    num = vNei.size();
                    for (j = 0; j < num; j++)
                    {
                        int neigh = vNei.at(j);
                        if (fDir[neigh] == -1)
                        {
                            if (count[neigh] == 0)
                                cand[ncand++] = neigh;
                            count[neigh]++;
                        }
                    }
                }
            }
            m = 0;
            for (i = 1; i < ncand; i++)
            {
                if (count[i] > count[m])
                    m = i;
            }
            m = cand[m];
            ncand = 0;
            bool already[numNodes];
            for (i = 0; i < numNodes; i++)
                already[i] = false;
            for (i = 0; i < numNodes; i++)
            {
                if (fDir[i] != -1)
                {
                    std::vector<int> vNei;
                    for (j = 0; j < numNodes; j++)
                    {
                        if(outAdjList[fDir[i]].find(j) != outAdjList[fDir[i]].end())
						//if (outAdjList[fDir[i]].containsKey(j))
                            vNei.push_back(j);
						else if(outAdjList[j].find(fDir[i]) != outAdjList[j].end())
                        //else if (outAdjList[j].containsKey(fDir[i]))
                            vNei.push_back(j);
                    }
                    num = vNei.size();
                    for (j = 0; j < num; j++)
                    {
                        int neigh = vNei.at(j);
                        if (!already[neigh] && fRev[neigh] == -1 && support[m * numNodes + neigh])
                        {
                            cand[ncand++] = neigh;
                            already[neigh] = true;
                        }
                    }
                }
            }
            for (i = 0; i < ncand; i++)
            {
                n = cand[i];
                flag = false;
                if (nodeLabels[n]==nodeLabels[m])
                {
                    for (j = 0; j < numNodes; j++)
                    {
                        if (fDir[j] != -1)
                        {
                            //TIntHashSet edgeLabs1=outAdjList[m].get(j);
							std::unordered_set<int> edgeLabs1 =  outAdjList[m][j];
                            //TIntHashSet edgeLabs2=outAdjList[n].get(fDir[j]);
							std::unordered_set<int> edgeLabs2 =  outAdjList[n][fDir[j]];
                            //if ((edgeLabs1==null && edgeLabs2!=null) ||
                                    //(edgeLabs1!=null && edgeLabs2==null) ||
                                    //(edgeLabs1!=null && !edgeLabs1.equals(edgeLabs2)))
							if(edgeLabs1!=edgeLabs2)
                            {
                                flag = true;
                                break;
                            }
                            else
                            {
                                //edgeLabs1=outAdjList[j].get(m);
								std::unordered_set<int> edgeLabs1 =  outAdjList[j][m];
                                //edgeLabs2=outAdjList[fDir[j]].get(n);
								std::unordered_set<int> edgeLabs2 =  outAdjList[fDir[j]][n];
                                //if ((edgeLabs1==null && edgeLabs2!=null) ||
                                        //(edgeLabs1!=null && edgeLabs2==null) ||
                                        //(edgeLabs1!=null && !edgeLabs1.equals(edgeLabs2)))
								if(edgeLabs1!=edgeLabs2)
                                {
                                    flag = true;
                                    break;
                                }
                            }

                        }
                    }
                    if(!flag)
                    {
                        fDir[m] = n;
                        fRev[n] = m;
                        pos++;
                        isomorphicExtensions(fDir, fRev, vv, support, pos);
                        pos--;
                        fRev[fDir[m]] = -1;
                        fDir[m] = -1;
                    }
                }
            }
        }
    }
	
	std::string toString()
	{
		std::string str = "";
		int i, j;
		for(i=0;i<this->numNodes;i++)
		{
			str += "("+ std::to_string(i);
			for(std::unordered_set<int>::iterator it = nodeLabels[i].begin(); it != nodeLabels[i].end(); it++)
			{
				int lab = *it;
				str += ","+std::to_string(lab);
			}
			str += ") --> ";
			for(std::unordered_map<int, std::unordered_set<int> > ::iterator it = outAdjList[i].begin(); it != outAdjList[i].end(); it++){
				int dest = it->first;
				str += "(" + std::to_string(dest);
				for(std::unordered_set<int>::iterator it2 = it->second.begin(); it2 != it->second.end(); it2++){
					int lab = *it2;
					str += "," + std::to_string(lab);
				}
				str+=") ";
			}
			str+="\n";
		}
		return str;
	}

	/*void print(){
		for(int i=0; i<numNodes; i++){
			std::cout<<"["<<std::to_string(i)<<"]{"<<std::to_string(nodeLabels[i])<<"}--|"<<std::endl;
			for(auto &it : outAdjList[i]){
				std::cout<<"\to["<<std::to_string(it.first)<<"]{";
				for(auto &it2 : it.second){
					std::cout<<  std::to_string(it2)<<",";
				}
				std::cout<<"}"<<std::endl;
			}
			for(auto &it : inAdjList[i]){
				std::cout<<"\ti["<<std::to_string(it.first)<<"]{";
				for(auto &it2 : it.second){
					std::cout<<  std::to_string(it2)<<",";
				}
				std::cout<<"}"<<std::endl;
			}
			//typedef std::unordered_multiset< std::unordered_set<int>, ushash > powerset_t *;
			//powerset_t * outgoingEdges;
		}

		//typedef std::unordered_multiset< std::unordered_set<int>, ushash > powerset_t;
		//powerset_t * outgoingEdges;
		std::cout<<"outgoing edges:"<<std::endl;
		for(int n=0; n<numNodes; n++){
			std::cout<<"OE["<< std::to_string(n)<<"]|"<< std::to_string( (outgoingEdges[n]).size() )  <<"|"<<std::endl;
			for(auto &um : outgoingEdges[n]){
				//std::cout<<"OE["<< std::to_string(n)<<"]|"<< std::to_string(um.size())  <<"|"<<std::endl;
				std::cout<<"\t{";
				for(auto &i : um){
					std::cout<< std::to_string(i)<<",";
				}
				std::cout<<"}\n";
			}
		}
	}*/

//	public String toString()
//	{
//		String str="";
//		int i;
//		for(i=0;i<outAdjList.length;i++)
//		{
//			str+="("+i+","+nodeLabels[i]+") --> ";
//			TIntIterator it=outAdjList[i].keySet().iterator();
//			while(it.hasNext())
//			{
//				int dest=it.next();
//				str += "(" + dest;
//				TIntHashSet setEdgeCols=outAdjList[i].get(dest);
//				TIntIterator itCols=setEdgeCols.iterator();
//				while(itCols.hasNext())
//				{
//					int lab=itCols.next();
//					str+=","+lab;
//				}
//				str+=") ";
//			}
//			str+="\n";
//		}
//		return str;
//	}



};

};

#endif //GRAPH_H_
