#ifndef MATCHLISTENER_H_
#define MATCHLISTENER_H_

namespace rimlib{

class MatchListener{
public:
	long matchcount;
	MatchListener(){
		matchcount = 0;
	}
	virtual ~MatchListener(){};
	virtual void match(int n, int* qIDs, int* rIDs)=0;
};


class EmptyMatchListener : public MatchListener {
public:
	EmptyMatchListener() : MatchListener(){
	}
	virtual void match(int n, int* qIDs, int* rIDs){
		matchcount++;
	};
};

class ConsoleMatchListener : public MatchListener {
public:
	ConsoleMatchListener() : MatchListener(){
	}
	virtual void match(int n, int* qIDs, int* rIDs){
		matchcount++;
		std::cout<< "{";
		for(int i=0; i<n; i++){
			std::cout<< "("<< qIDs[i] <<","<< rIDs[i] <<")";
		}
		std::cout<< "}\n";
	}
};

}


#endif /* MATCHLISTENER_H_ */
