#include <iostream>
#include <sstream>

//#include "rimlib/LabelMap.h"
#include "rimlib/Graph.h"
#include "rimlib/FileManager.h"
#include "rimlib/MatchingMachine.h"
#include "rimlib/MatchListener.h"
#include "rimlib/RISolver.h"

#include <unordered_set>
#include <set>

using namespace rimlib;




int main(int argc, char* argv[]){


//	struct ushash {
//	   size_t operator() (const std::unordered_set<int> &obj) const {
//		   size_t h = 0;  for(auto &k : obj) h += k;
//	     return (h);
//	   }
//	};
//	std::unordered_set< std::unordered_set<int>, ushash> insieme;
//	std::unordered_multiset< std::unordered_set<int>, ushash > insieme;
//	std::unordered_set<int> a;
//	std::unordered_set<int> b;
//	std::unordered_set<int> c;
//	std::unordered_set<int> d;
//	a.insert(0);
//	a.insert(1);
//	a.insert(2);
//	b.insert(0);
//	b.insert(2);
//	c.insert(0);
//	c.insert(2);
//	d.insert(0);
//	d.insert(1);
//	insieme.insert(a);
//	insieme.insert(b);
//	std::unordered_set< std::unordered_set<int>, ushash >::iterator it = insieme.find(c);
//	if(it != insieme.end()){
//		std::cout<<"c is contained"<<std::endl;
//	}
//	it = insieme.find(d);
//	if(it != insieme.end()){
//		std::cout<<"d is contained"<<std::endl;
//	}
//	exit(0);


	FileManager fm;
	std::cout << "-----------------------------------------" << std::endl;
	std::string tfile = std::string(argv[1]);
	std::cout<<tfile<<std::endl;

	Graph * target = fm.readGraph( tfile, false);
	//std::cout<< target->toString();

	std::string qfile = std::string(argv[2]);
	std::cout<<qfile<<std::endl;

	Graph * query = fm.readGraph( qfile, false);
	//std::cout<< query->toString();

	//query->print();
	clock_t start = clock();
	sbitset * domains = new sbitset[query->numNodes];
	MatchingMachine mama(*query,domains);
	//mama.print();

	//MatchListener * mlistener = new ConsoleMatchListener();
	MatchListener * mlistener = new EmptyMatchListener();
	RISolver solver(mama, *target, *query, *mlistener);
	//std::cout<<"solving..."<<std::endl;
	solver.match();
	std::cout<<"Number of matches: "<< mlistener->matchcount <<std::endl;
	double runningTime = double(clock()- start)/CLOCKS_PER_SEC;
	std::cout << "Time elapsed: "<< runningTime << " secs" << std::endl;

	//std::cout<<"done"<<std::endl;

	/*
	Graph g(true, 10);
	for(int i=0; i<10; i++){
		g.addNode(i, i);
	}
	for(int i=1; i<10; i++){
		std::unordered_set< int > edgeLabels;
		for(int j=0; j<i; j++){
			edgeLabels.insert(j);
		}
		g.addEdge(i, i-1, edgeLabels);
	}
	std::cout<< g.toString();
	std::cout<<"done"<<std::endl;
	*/

	return 0;
}
